_G.HeisterVoiceChanger = _G.HeisterVoiceChanger or {}

HeisterVoiceChanger.ModPath = ModPath
HeisterVoiceChanger.SavePath = SavePath .. "HeisterVoiceChanger.txt"
HeisterVoiceChanger.Options = HeisterVoiceChanger.Options or {}

HeisterVoiceChanger.Menu = "HeisterVoiceChangerMenu"

function HeisterVoiceChanger:Save()

	local data = io.open( self.SavePath , "w+" )
	
	if data then
		data:write( json.encode( self.Options ) )
		data:close()
	end
	
end

function HeisterVoiceChanger:Load()

	local data = io.open( self.SavePath , "r" )
	
	if data then
		self.Options = json.decode( data:read( "*all" ) )
		data:close()
	end
	
end

Hooks:Add( "MenuManagerSetupCustomMenus" , "HeisterVoiceChangerPostMenuManagerSetupCustomMenus" , function( self , nodes )
    
	MenuHelper:NewMenu( HeisterVoiceChanger.Menu )
	
end )

Hooks:Add( "LocalizationManagerPostInit" , "HeisterVoiceChangerPostLocalizationManagerInit" , function( self )

	self:add_localized_strings({
		[ "HeisterVoiceChangerT" ] = "Heister Voice Changer",
		[ "HeisterVoiceChangerD" ] = "Who says you can't impersonate someone else?"
	})
	
	for i , c in ipairs( tweak_data.criminals.characters ) do
	
		HeisterVoiceChanger.Characters = HeisterVoiceChanger.Characters or {}
		table.insert( HeisterVoiceChanger.Characters , "menu_" .. c.name )
		
	end
	
	HeisterVoiceChanger:Load()

end )

Hooks:Add( "MenuManagerBuildCustomMenus" , "HeisterVoiceChangerPostMenuManagerBuildCustomMenus" , function( self , nodes )

    nodes[ HeisterVoiceChanger.Menu ] = MenuHelper:BuildMenu( HeisterVoiceChanger.Menu )
    MenuHelper:AddMenuItem( nodes["blt_options"] , HeisterVoiceChanger.Menu , "HeisterVoiceChangerT" , "HeisterVoiceChangerD" )
	
end )

Hooks:Add( "MenuManagerPopulateCustomMenus" , "HeisterVoiceChangerPostMenuManagerPopulateCustomMenus" , function( self , nodes )

	-- if tweak_data.criminals.characters then
	-- 	-- for _, character_data in ipairs(tweak_data.criminals.characters) do
	-- 	tweak_data.criminals.characters[HeisterVoiceChanger.Options[name] ].static_data.voice
	-- 		-- return voicec
	-- 	-- end
	-- end

	for i , c in ipairs( tweak_data.criminals.characters ) do
	
		local name = c.name

		-- if HeisterVoiceChanger.Options[name] then
		-- 	local voicec = tweak_data.criminals.characters[HeisterVoiceChanger.Options[name] ].static_data.voice
		-- 	return voicec
		-- end
		
		MenuCallbackHandler[ name .. "_voice" ] = function( self , item )
			HeisterVoiceChanger.Options[ name ] = item:value()
			HeisterVoiceChanger:Save()
		end
		
		MenuHelper:AddMultipleChoice({
			id 			= "HVC_" .. name .. "_voice",
			title 		= "menu_" .. name,
			desc 		= "",
			callback 	= name .. "_voice",
			items 		= HeisterVoiceChanger.Characters,
			menu_id 	= HeisterVoiceChanger.Menu,
			value 		= HeisterVoiceChanger.Options[ name ] or i
		})
	
	end

end )